#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  LimeGreen
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Maroon
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2
#property  indicator_width4  2

extern ENUM_TIMEFRAMES    TimeFrame = PERIOD_CURRENT;
extern ENUM_APPLIED_PRICE Price     = PRICE_WEIGHTED;
extern int                FastEMA   = 12;
extern int                SlowEMA   = 26;
extern int                SignalSMA = 9;

double     ind_buffer1[], ind_buffer1s[];
double     ind_buffer2[], ind_buffer2s[];
double     ind_buffer3[], slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(6);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   SetIndexBuffer(0,ind_buffer1);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ind_buffer1s); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ind_buffer2);  SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ind_buffer2s); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ind_buffer3);
   SetIndexBuffer(5,slope);
      TimeFrame = MathMax(TimeFrame,_Period);
   IndicatorShortName("OsMA("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,3*TimeFrame/_Period),Bars-1);

   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      ind_buffer3[i]  = iOsMA(NULL,TimeFrame,FastEMA,SlowEMA,SignalSMA,Price,y);
      ind_buffer2[i]  = EMPTY_VALUE;
      ind_buffer2s[i] = EMPTY_VALUE;
      ind_buffer1[i]  = EMPTY_VALUE;
      ind_buffer1s[i] = EMPTY_VALUE;             
      slope[i]        = slope[i+1];
         if (ind_buffer3[i]>ind_buffer3[i+1]) slope[i] =  1;
         if (ind_buffer3[i]<ind_buffer3[i+1]) slope[i] = -1;
         if (ind_buffer3[i]<0)
               if (slope[i]== -1) 
                     ind_buffer2s[i]=ind_buffer3[i];
               else  ind_buffer2[i] =ind_buffer3[i];
         if (ind_buffer3[i]>0)
               if (slope[i]== -1) 
                     ind_buffer1s[i]=ind_buffer3[i];
               else  ind_buffer1[i] =ind_buffer3[i];
     }
   return(0);
}